/**
 * @author ROLLAND Martin & COUVIDOU Laurent
 *
 * LO42 - TP2
 * Complexit des algorithmes
 * Mthodes de tri d'un tableau
 * Dcommenter le tri dsir dans le main
 */

public class Tri {
	
	/**
	 * Constantes
	 */

	// Taille du tableau
	final static int TAI = 40;
	
	// Priode de simulation en ms
	final static int PER = 2;
	
	/**
	 * Initialisation
	 */	
	
    // Dclaration de la simulation
	static donnees_visu simu;
	
	static void initialisation(){
 
		simu = new donnees_visu(PER);
		simu.definition_taille(TAI);
	}

	/**
	 * Les tris
	 */
	
	static void triInsertion() {

		int i = 0, taille = simu.taille();
		while (i < taille) {
			i++;
			int elt, j, k;
			for (j = 1; j < taille; j++) {
				k = j - 1;
				elt = simu.getValue(j);
				while ((k >= 0) && (simu.sup(k, elt))) {
					simu.setValue(k + 1, simu.getValue(k));
					k--;
				}
				simu.setValue(k + 1, elt);
			}
		}
	}

	static void triShell() {

		int taille = simu.taille();
		int n = 0;

		while (n < taille) {
			n = 3 * n + 1;
		}

		while (n != 0) {
			n = n / 3;
			for (int i = n; i < taille; i++) {
				int elt = simu.getValue(i);
				int j = i;

				while ((j > (n - 1)) && (simu.sup(j - n, elt))) {
					simu.setValue(j, simu.getValue(j - n));
					j = j - n;
				}
				simu.setValue(j, elt);
			}
		}
	}

	static void triFusion() {

		int taille = simu.taille();
		if (taille > 0) {
			triFusion(0, taille - 1);
		}
	}

	private static void triFusion(int deb, int fin) {

		if (deb != fin) {
			int milieu = (fin + deb) / 2;
			triFusion(deb, milieu);
			triFusion(milieu + 1, fin);
			fusion(deb, milieu, fin);
		}
	}

	private static void fusion(int deb1, int fin1, int fin2) {

		int deb2 = fin1 + 1;

		//on recopie les lments du dbut du tableau
		int table1[] = new int[fin1 - deb1 + 1];
		for (int i = deb1; i <= fin1; i++) {
			table1[i - deb1] = simu.getValue(i);
		}

		int compt1 = deb1;
		int compt2 = deb2;

		for (int i = deb1; i <= fin2; i++) {
			if (compt1 == deb2) //c'est que tous les lments du premier
			// tableau ont t utiliss
			{
				break; //tous les lments ont donc t classs
			} else if (compt2 == (fin2 + 1)) //c'est que tous les lments du
			// second tableau ont t utiliss
			{
				simu.setValue(i, table1[compt1 - deb1]); //on ajoute les
				// lments
				// restants du premier
				// tableau
				compt1++;
			} else if (simu.sup(compt2, table1[compt1 - deb1])) {
				simu.setValue(i, table1[compt1 - deb1]); //on ajoute un lment
				// du
				// premier tableau
				compt1++;
			} else {
				simu.setValue(i, simu.getValue(compt2)); //on ajoute un lment
				// du second
				// tableau
				compt2++;
			}
		}
	}

	static void triBullesIteratif() {

		int inv = 1, taille = simu.taille(), n = taille;
		while (inv == 1) {
			inv = 0;
			for (int i = 0; i < n; i++)
				if (simu.supIndex(i, i + 1)) {
					simu.echange(i, i + 1);
					inv = 1;
				}
			n--;
		}
	}

	static void triBullesRecursif() {

		int taille = simu.taille();
		triBullesRecursif(taille);
	}

	private static void triBullesRecursif(int n) {

		bulle(0, n);
		if (n > 1)
			triBullesRecursif(n - 1);
		// else rien : cas d'arrt
	}

	private static void bulle(int i, int n) {

		if (simu.supIndex(i, i + 1))
			simu.echange(i, i + 1);
		if (i < n - 1)
			bulle(i + 1, n);
		// else rien : cas d'arrt
	}

	static void triRapideRecursif() {
		int taille = simu.taille();
		triRapideRecursif(0, taille - 1);
	}

	private static void triRapideRecursif(int deb, int fin) {
		if (deb < fin) {
			int positionPivot = partition(deb, fin);
			triRapideRecursif(deb, positionPivot - 1);
			triRapideRecursif(positionPivot + 1, fin);
		}
	}

	private static int partition(int deb, int fin) {
		
		int compt = deb;
		int pivot = simu.getValue(deb);

		for (int i = deb + 1; i <= fin; i++) {
			if (simu.inf(i, pivot)) {
				compt++;
				simu.echange(compt, i);
			}
		}
		simu.echange(deb, compt);
		return (compt);
	}
	
	static void triRapideIteratif(){
		
		// A FAIRE
	}
	
	/**
	 * Affichage du nombre d'affectations et de comparaisons
	 * (dans la consoles Java)
	 */

	static void bilan() {

		System.out.println("nbre affectations= " + simu.nbAffectation);
		System.out.println("nbre comparaisons= " + simu.nbComparaison);
	}

	/**
	 * Programme principal
	 */
	
	public static void main(String args[]) {

		initialisation();
		//triInsertion();
		//triShell();
		//triFusion();
		//triBullesIteratif();
		//triBullesRecursif();
		//triRapideRecursif();
		triRapideIteratif();
		bilan();
	}
}